module Element
  def self.included(base)
    base.extend(ClassMethods)
    base.__send__ :include, InstanceMethods
  end
  
  module ClassMethods
    def list_opt_for_panel
      {}
    end
    
    def show_opt_for_panel
      {}
    end
    
    def json_opt_for_panel
      {}
    end
    
    def path_name with_engine = false
      self.to_s.tableize
    end
    
  end
  
  module InstanceMethods
    private
    
    public
    
    def has_picture?
      false
    end
    
    def path_name with_engine = false
      self.class.path_name(with_engine)
    end
    
    def form_template with_engine = false
      self.path_name(with_engine) + '/form'
    end
    
    def scenario_template with_engine = false
      self.path_name(with_engine) + '/scenario'
    end
    
    def element_face_template with_engine = false
      self.path_name(with_engine) + '/element_face'
    end
    
  end
end

