class CreateComics < ActiveRecord::Migration
  def change
    create_table :comics do |t|
      t.string :title, :null => false, :limit => 100
      t.integer :width, :null => false
      t.integer :height, :null => false
      t.integer :visible, :null => false, :default => 0
      t.integer :editable, :null => false, :default => 0
      t.integer :author_id, :null => false

      t.timestamps
    end
    add_index :comics, [:author_id]
  end
end
